"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = void 0;
var package_utils_1 = require("@monorepo-utils/package-utils");
exports.plugin = function (options) {
    var monorepoPackages = package_utils_1.getPackages(options.rootDir);
    return {
        supports: function () {
            return monorepoPackages.length > 0;
        },
        getAllPackages: function () {
            return monorepoPackages;
        },
        getDependencies: function (packageJSON) {
            var _a, _b;
            var dependencies = Object.entries((_a = packageJSON.dependencies) !== null && _a !== void 0 ? _a : {});
            var devDependencies = Object.entries((_b = packageJSON.devDependencies) !== null && _b !== void 0 ? _b : {});
            return __spreadArrays(dependencies, [devDependencies]).map(function (dep) {
                return {
                    name: dep[0]
                };
            });
        },
        resolve: function (_a) {
            var name = _a.name;
            var matchPkg = monorepoPackages.find(function (info) {
                return info.packageJSON.name === name;
            });
            if (!matchPkg) {
                return null;
            }
            return matchPkg.location;
        }
    };
};
//# sourceMappingURL=npm.js.map