var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import meow from "meow";
import { toProjectReferences } from "./index";
export var cli = meow("\n    Usage\n      $ workspaces-to-typescript-project-references\n \n\n    Options\n      --root             [Path:string] Root directory of the monorepo. \n                         Default: current working directory\n      --check            If set the flag, check only differences of tsconfig.json and does not update tsconfig.json.\n                         If the check is failed, exit status 1. It is useful for testing.\n       \n      --plugin           [Path:string] Path to plugin script.\n                         Load the plugin script as module and use it. \n                           \n    Examples\n      # Update project references in tsconfig.json\n      $ workspaces-to-typescript-project-references\n      # Test on CI\n      $ workspaces-to-typescript-project-references --check\n", {
    flags: {
        root: {
            type: "string",
            default: process.cwd()
        },
        check: {
            type: "boolean",
            default: false
        },
        plugin: {
            type: "string",
            isMultiple: true
        }
    },
    autoHelp: true,
    autoVersion: true
});
export var run = function (_input, flags) {
    if (_input === void 0) { _input = cli.input; }
    if (flags === void 0) { flags = cli.flags; }
    return __awaiter(void 0, void 0, void 0, function () {
        var plugins, result;
        return __generator(this, function (_a) {
            plugins = flags.plugin ? flags.plugin.map(function (pluginPath) { return require(pluginPath); }) : undefined;
            result = toProjectReferences({
                rootDir: flags.root,
                checkOnly: flags.check,
                plugins: plugins
            });
            if (result.ok) {
                return [2 /*return*/, {
                        exitStatus: 0,
                        stdout: flags.check ? "" : "Update Project References!",
                        stderr: null
                    }];
            }
            else if (result.aggregateError) {
                return [2 /*return*/, {
                        exitStatus: 1,
                        stdout: null,
                        stderr: result.aggregateError.message + "\n\n" + result.aggregateError.errors.join("\n")
                    }];
            }
            return [2 /*return*/, {
                    exitStatus: 0,
                    stdout: null,
                    stderr: null
                }];
        });
    });
};
//# sourceMappingURL=cli.js.map